#include "sigslot.hpp"

#include <stdio.h>

class co {
public:
  co() : mynr(count++) {def++;showstat("Default Constructor");};
  co(const co &) : mynr(count++) {cop++;showstat("Copy constructor");};
  co &operator= (const co &) {asg++;showstat("Assignment operator");return *this;};
  ~co() {dst++;showstat("Destructor");};
  void showstat(char *x) const {printf("%s #%d\n",x,mynr);};
  int mynr;
  static int count,def,cop,asg,dst;
};
int co::count=0;
int co::def=0;
int co::cop=0;
int co::asg=0;
int co::dst=0;



class sender {
public:
  Signal3<int,char,co> sigx;
  Signal2<char,char> sigs;
  Signal1<float> sigf;
  Signal0 sigz;
  
  void send();
};

void sender::send()
{
  sigx(1,'X',co());
  sigs('<','>');
  sigf(4.34534);
  sigz();
};


class receiver {
public:
  receiver();
  
  void recvrout(const int&,const char&,const co&);
  void recvs(const char &,const char &);
  void recvf(const float &);
  void recvz();
  Slot3<receiver,int,char,co> slotx;
  Slot2<receiver,char,char> slots;
  Slot1<receiver,float> slotf;
  Slot0<receiver> slotz;
};

receiver::receiver() :
  slotx(this,&receiver::recvrout),
  slots(this,&receiver::recvs),
  slotf(this,&receiver::recvf),
  slotz(this,&receiver::recvz)
{
};

void receiver::recvrout(const int &a,const char &b,const co &c)
{
  printf("3 parameter call!  %d  %c\n",a,b);
  c.showstat("co testclass in slot routine ");
};

void receiver::recvs(const char &a,const char &b)
{
  printf("The worlds first 2 parameter slot call: %c%c\n",a,b);
};

void receiver::recvf(const float &f)
{
  printf("receiver 1 parameter float %f\n",f);
};

void receiver::recvz()
{
  printf("parameter ZERO RECEIVER!!!\n");
};

int main()
{
  sender *s=new sender;
  receiver *r=new receiver;
  Connect(s->sigx,r->slotx,CONNECT_SHOT);
  Connect(s->sigs,r->slots,CONNECT_SHOT);
  Connect(s->sigf,r->slotf,CONNECT_DEFER);
  Connect(s->sigz,r->slotz,CONNECT_DEFER);
  s->send();
  delete s;
  
  printf("now processing queue\n");
  mainQueue::run();
  delete r;
  
  printf("Default Constructor calls : %d\n",co::def);
  printf("Copy Constructor calls    : %d\n",co::cop);
  printf("Assignment operator calls : %d\n",co::asg);
  printf("Destructor calls          : %d\n",co::dst);
  
  return 0;
};
