#include "fatal.hpp"

#include <fcntl.h>
#include <sys/stat.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>

class out {
public:
  out(char *filename);
  ~out();
  void psl(char *l[]);
  void ps(char *s);
  void pc(char c);
  void pn(long long n);
private:
  int handle;
};

out::out(char *filename)
{
  if ((handle=creat(filename, S_IWRITE | S_IREAD))<0)
    fatalerror("Fehler beim Erstellen der Datei");
  printf("CREATING %s...\n",filename);
};

out::~out()
{
  printf("...done!\n");
  close(handle);
};

void out::psl(char *l[])
{
  while (*l) {
    ps(*l);
    pc('\n');
    l++;
  };
};

void out::ps(char *s)
{
  //	printf(s);
  if (write(handle,s,strlen(s))<0) fatalerror("write failed");
};

void out::pc(char c)
{
  char x[2];
  x[0]=c;
  x[1]=0;
  ps(x);
};

void out::pn(long long n)
{
  char x[100];
  sprintf(x,"%lld",n);
  ps(x);
};


out *O;
int anz;


char *header[] = {
"// ***************************************************************         ",
"// *** Automatically generated by gencode.cpp. do NOT edit !!! ***         ",
"// ***************************************************************         ",
"                                                                           ",
"#ifndef __SIGSLOT_HPP                                                      ",
"#define __SIGSLOT_HPP                                                      ",
"                                                                           ",
"#include \"fatal.hpp\"                                                     ",
"                                                                           ",
"enum connectmode_t {CONNECT_DEFER,CONNECT_SHOT};                           ",
"                                                                           ",
"                                                                           ",
"class CommonEvent {                                                        ",
"public:                                                                    ",
"  CommonEvent ();                                                          ",
"  CommonEvent(const CommonEvent &);                                        ",
"  CommonEvent & operator= (const CommonEvent &);                           ",
"  virtual ~CommonEvent ();                                                 ",
"                                                                           ",
"  virtual void operator()()=0;                                             ",
"                                                                           ",
"  CommonEvent *nextmainqueue, *prevmainqueue;                              ",
"  CommonEvent *nextslotevent, *prevslotevent;                              ",
"};                                                                         ",
"                                                                           ",
"                                                                           ",
"class mainQueue {                                                          ",
"public:                                                                    ",
"  static void run();                                                       ",
"                                                                           ",
"  static CommonEvent *first,*last;                                         ",
"};                                                                         ",
"                                                                           ",
"                                                                           ",
"class Signal0;                                                             ",
"                                                                           ",
"                                                                           ",
0};


char *cppfile[] = {
"// ***************************************************************         ",
"// *** Automatically generated by gencode.cpp. do NOT edit !!! ***         ",
"// ***************************************************************         ",
"                                                                           ",
"#include \"sigslot.hpp\"                                                   ",
"                                                                           ",
"#include <stdio.h>                                                         ",
"                                                                           ",
"                                                                           ",
"CommonEvent::CommonEvent ()                                                ",
"  : nextmainqueue(0), prevmainqueue(0), nextslotevent(0), prevslotevent(0) ",
"{                                                                          ",
"};                                                                         ",
"                                                                           ",
"CommonEvent::~CommonEvent()                                                ",
"{                                                                          ",
"};                                                                         ",
"                                                                           ",
"                                                                           ",
"void mainQueue::run()                                                      ",
"{                                                                          ",
"  CommonEvent *old;                                                        ",
"  while (first) {                                                          ",
"    (*first)();                                                            ",
"    old=first;                                                             ",
"    first=first->nextmainqueue;                                            ",
"    delete old;                                                            ",
"    if (first) first->prevmainqueue=0;                                     ",
"  };                                                                       ",
"  last=0;                                                                  ",
"};                                                                         ",
"                                                                           ",
"CommonEvent *mainQueue::first=0;                                           ",
"CommonEvent *mainQueue::last=0;                                            ",
"                                                                           ",
"                                                                           ",
0};


void mk_nr()
{
  O->pn(anz);
};

void mk_classp1_classp2_classp3()
{
  for (int x=1;x<anz+1;x++) {
    O->ps("class p");
    O->pn(x);
    if (x!=anz) O->ps(", ");
  };
};

void mk_template_kl_classp1_classp2_classp3_gr()
{
  if (anz) O->ps("template<");
  mk_classp1_classp2_classp3();
  if (anz) O->ps(">\n");
};

void mk_constp1refa1_constp2refa2_constp3refa3()
{
  for (int x=1;x<anz+1;x++) {
    O->ps("const p");
    O->pn(x);
    O->ps(" &a");
    O->pn(x);
    if (x!=anz) O->ps(", ");
  };
};

void mk_constp1refa1__constp2refa2__constp3refa3_()
{
  for (int x=1;x<anz+1;x++) {
    O->ps("const p");
    O->pn(x);
    O->ps(" &a");
    O->pn(x);
    O->pc('_');
    if (x!=anz) O->ps(", ");
  };
};

void mk_p1_p2_p3()
{
  for (int x=1;x<anz+1;x++) {
    O->pc('p');
    O->pn(x);
    if (x!=anz) O->ps(", ");
  };
};

void mk_a1_a2_a3()
{
  for (int x=1;x<anz+1;x++) {
    O->pc('a');
    O->pn(x);
    if (x!=anz) O->ps(", ");
  };
};

void mk_kl_p1_p2_p3_gr()
{
  if (anz) O->pc('<');
  mk_p1_p2_p3();
  if (anz) O->pc('>');
};

void mk_private_copies()
{
  for (int x=1;x<anz+1;x++) {
    O->pc('p');
    O->pn(x);
    O->ps(" a");
    O->pn(x);
    O->pc(';');
    if (x!=anz) O->pc(' ');
  };
};

void mk_template_kl_classT_classp1_classp2_classp3_gr()
{
  O->ps("template<class T");
  if (anz) O->ps(", ");
  mk_classp1_classp2_classp3();
  O->ps(">\n");
};

void mk_constp1ref_constp2ref_constp3ref()
{
  for (int x=1;x<anz+1;x++) {
    O->ps("const p");
    O->pn(x);
    O->ps(" &");
    if (x!=anz) O->ps(", ");
  };
};

void mk_kl_T_p1_p2_p3_gr()
{
  O->ps("<T");
  if (anz) O->ps(", ");
  mk_p1_p2_p3();
  O->ps(">");
};

void mk_a1a1__a2a2__a3a3_()
{
  for (int x=1;x<anz+1;x++) {
    O->ps("a");O->pn(x);
    O->ps("(a");O->pn(x);
    O->ps("_)");
    if (x!=anz) O->ps(", ");
  };
};

void mk_CommonSlotX_header()
{
	mk_template_kl_classp1_classp2_classp3_gr();
	O->ps("class CommonSlot");mk_nr();O->ps(" {\n");
	O->ps("public:\n");
	O->ps("  CommonSlot");mk_nr();O->ps(" ();\n");
	O->ps("  CommonSlot");mk_nr();O->ps(" (const CommonSlot");mk_nr();
		O->ps(" &);\n");
	O->ps("  CommonSlot");mk_nr();
		O->ps(" & operator= (const CommonSlot");mk_nr();O->ps(" &);\n");
	O->ps("  virtual ~CommonSlot");mk_nr();O->ps("();\n");
	O->pc('\n');
	O->ps("  virtual void operator ()(");
		mk_constp1refa1_constp2refa2_constp3refa3();
		O->ps(") =0;\n");
	O->pc('\n');
	O->ps("  Signal");mk_nr();
		mk_kl_p1_p2_p3_gr();O->ps(" *mysig;\n");
	O->ps("  CommonEvent *first, *last;\n");
	O->ps("};\n");
	O->pc('\n');
};

void mk_EventX_header()
{
	mk_template_kl_classp1_classp2_classp3_gr();
	O->ps("class Event");mk_nr();O->ps(" : public CommonEvent {\n");
	O->ps("public:\n");
	O->ps("  Event");mk_nr();O->ps(" (const Event");mk_nr();
		O->ps(" &);\n");
	O->ps("  Event");mk_nr();
		O->ps(" & operator= (const Event");mk_nr();O->ps(" &);\n");
	O->ps("  Event");mk_nr();O->ps(" (CommonSlot");mk_nr();
		mk_kl_p1_p2_p3_gr();O->ps(" *Slot_");
		if (anz) O->ps(", ");
		mk_constp1refa1__constp2refa2__constp3refa3_();O->ps(");\n");
	O->pc('\n');
	O->ps("  void operator ()();\n");
	O->pc('\n');
	O->ps("private:\n");
	O->ps("  CommonSlot");mk_nr();mk_kl_p1_p2_p3_gr();
		O->ps(" *Slot;\n");
	O->pc('\n');
	O->ps("  ");mk_private_copies();O->pc('\n');
	O->ps("};\n");
	O->pc('\n');
};

void mk_SignalX_header()
{
	mk_template_kl_classp1_classp2_classp3_gr();
	O->ps("class Signal");mk_nr();O->ps(" {\n");
	O->ps("public:\n");
	O->ps("  Signal");mk_nr();O->ps(" ();\n");
	O->ps("  Signal");mk_nr();O->ps(" (const Signal");mk_nr();
		O->ps(" &);\n");
	O->ps("  Signal");mk_nr();
		O->ps(" & operator= (const Signal");mk_nr();O->ps(" &);\n");
	O->ps("  ~Signal");mk_nr();O->ps(" ();\n");
	O->pc('\n');
	O->ps("  void operator ()(");mk_constp1refa1_constp2refa2_constp3refa3();
		O->ps(");\n");
	O->pc('\n');
	O->ps("  CommonSlot");mk_nr();mk_kl_p1_p2_p3_gr();
		O->ps(" *myslot;\n");
	O->pc('\n');
	O->ps("  connectmode_t connectmode;\n");
	O->ps("};\n");
	O->pc('\n');
};

void mk_SlotX_header()
{
	mk_template_kl_classT_classp1_classp2_classp3_gr();
	O->ps("class Slot");mk_nr();O->ps(" : public CommonSlot");
		mk_nr();mk_kl_p1_p2_p3_gr();O->ps(" {\n");
	O->ps("public:\n");
	O->ps("  Slot");mk_nr();O->ps(" (const Slot");mk_nr();
		O->ps(" &);\n");
	O->ps("  Slot");mk_nr();
		O->ps(" & operator= (const Slot");mk_nr();O->ps(" &);\n");
	O->ps("  ~Slot");mk_nr();O->ps(" ();\n");
	O->ps("  Slot");mk_nr();O->ps(" (T *funcclass_, void (T::*func_)(");
		mk_constp1ref_constp2ref_constp3ref();O->ps("));\n");
	O->pc('\n');
	O->ps("  void operator ()(");mk_constp1refa1_constp2refa2_constp3refa3();
		O->ps(");\n");
	O->pc('\n');
	O->ps("  T *funcclass;\n");
	O->ps("  void (T::*func)(");mk_constp1ref_constp2ref_constp3ref();
		O->ps(");\n");
	O->ps("};\n");
	O->pc('\n');
};

void mk_Connect_function()
{
	mk_template_kl_classT_classp1_classp2_classp3_gr();
	O->ps("void Connect (Signal");mk_nr();mk_kl_p1_p2_p3_gr();
		O->ps(" & sig, Slot");mk_nr();mk_kl_T_p1_p2_p3_gr();
		O->ps(" & slot, connectmode_t connectmode_)\n");
	O->ps("{\n");
	O->ps("  if (sig.myslot)\n");
	O->ps("    fatalerror(\"Connect<");mk_nr();
		O->ps(" Parameter>: Signal already in use\");\n");
	O->ps("  sig.myslot=&slot;\n");
	O->ps("  sig.connectmode=connectmode_;\n");
	O->ps("  if (slot.mysig)\n");
	O->ps("    fatalerror(\"Connect<");mk_nr();
		O->ps(" Parameter>: Slot already in use\");\n");
	O->ps("  slot.mysig=&sig;\n");
	O->ps("};\n");
	O->pc('\n');
};

void mk_CommonSlotX_body()
{
	mk_template_kl_classp1_classp2_classp3_gr();
	O->ps("CommonSlot");mk_nr();mk_kl_p1_p2_p3_gr();O->ps("::CommonSlot");
		mk_nr();O->ps(" () : mysig(0), first(0), last(0)\n");
	O->ps("{\n");
	O->ps("}\n");
	O->pc('\n');

	mk_template_kl_classp1_classp2_classp3_gr();
	O->ps("CommonSlot");mk_nr();mk_kl_p1_p2_p3_gr();O->ps("::~CommonSlot");
		mk_nr();O->ps(" ()\n");
	O->ps("{\n");
	O->ps("}\n");
	O->pc('\n');
};

void mk_EventX_body()
{
	mk_template_kl_classp1_classp2_classp3_gr();
	O->ps("Event");mk_nr();mk_kl_p1_p2_p3_gr();O->ps("::Event");
		mk_nr();O->ps(" (CommonSlot");mk_nr();mk_kl_p1_p2_p3_gr();
		O->ps(" *Slot_");
		if (anz) O->ps(", ");
		mk_constp1refa1__constp2refa2__constp3refa3_();
		O->ps(")\n");
	O->ps("  : Slot(Slot_)");
		if (anz) O->ps(", ");
		mk_a1a1__a2a2__a3a3_();
		O->pc('\n');
	O->ps("{\n");
	O->ps("}\n");
	O->pc('\n');

	mk_template_kl_classp1_classp2_classp3_gr();
	O->ps("void Event");mk_nr();mk_kl_p1_p2_p3_gr();O->ps("::operator ()()\n");
	O->ps("{\n");
	O->ps("  Slot->first=Slot->first->nextslotevent;\n");
	O->ps("  if (Slot->first) Slot->first->prevslotevent=0; else Slot->last=0;\n");
	O->ps("  (*Slot)(");mk_a1_a2_a3();O->ps(");\n");
	O->ps("}\n");
	O->pc('\n');
};

void mk_SignalX_body()
{
	mk_template_kl_classp1_classp2_classp3_gr();
	O->ps("Signal");mk_nr();mk_kl_p1_p2_p3_gr();O->ps("::Signal");mk_nr();
		O->ps(" ()\n");
	O->ps("  : myslot(0)\n");
	O->ps("{\n");
//	O->ps("  printf(\"Signal");mk_nr();O->ps(" constructed\\n\");\n");
	O->ps("};\n");
	O->pc('\n');

	mk_template_kl_classp1_classp2_classp3_gr();
	O->ps("Signal");mk_nr();mk_kl_p1_p2_p3_gr();O->ps("::~Signal");mk_nr();
		O->ps(" ()\n");
	O->ps("{\n");
//	O->ps("  printf(\"Signal");mk_nr();O->ps(" destructed\\n\");\n");
	O->ps("  if (myslot) {\n");
//	O->ps("    printf(\"~Signal");mk_nr();O->ps(": I am connected to a slot. disconnecting...\\n\");\n");
	O->ps("    myslot->mysig=0;\n");
	O->ps("  }else{\n");
//	O->ps("    printf(\"~Signal");mk_nr();O->ps(": I ain't connected.\\n\");\n");
	O->ps("  };\n");
	O->ps("};\n");
	O->pc('\n');

	mk_template_kl_classp1_classp2_classp3_gr();
	O->ps("void Signal");mk_nr();mk_kl_p1_p2_p3_gr();O->ps("::operator ()(");
		mk_constp1refa1_constp2refa2_constp3refa3();O->ps(")\n");
	O->ps("{\n");
	O->ps("  if (myslot) {\n");
//	O->ps("    printf(\"Yes we are connected.\\n\");\n");
	O->ps("    if (connectmode == CONNECT_DEFER) {\n");
//	O->ps("      printf(\"Defered Connect\\n\");\n");
	O->ps("      CommonEvent *x=new Event");mk_nr();mk_kl_p1_p2_p3_gr();
		O->ps("(myslot");
		if (anz) O->ps(", ");
		mk_a1_a2_a3();
		O->ps(");\n");
	O->ps("      if (myslot->last) {\n");
	O->ps("        myslot->last->nextslotevent=x;\n");
	O->ps("        x->prevslotevent=myslot->last;\n");
	O->ps("        myslot->last=x;\n");
	O->ps("      }else{\n");
	O->ps("        myslot->first=myslot->last=x;\n");
	O->ps("      };\n");
	O->ps("      if (mainQueue::last) {\n");
	O->ps("        mainQueue::last->nextmainqueue=x;\n");
	O->ps("        x->prevmainqueue=mainQueue::last;\n");
	O->ps("        mainQueue::last=x;\n");
	O->ps("      }else{\n");
	O->ps("        mainQueue::first=mainQueue::last=x;\n");
	O->ps("      };\n");
	O->ps("    }else{ // CONNECT_SHOT\n");
//	O->ps("      printf(\"Shot connect\\n\");\n");
	O->ps("      (*myslot)(");mk_a1_a2_a3();O->ps(");\n");
	O->ps("    };\n");
	O->ps("  }else{\n");
//	O->ps("    printf(\"No connection, signal lost\\n\");\n");
	O->ps("  };\n");
	O->ps("};\n");
	O->pc('\n');
};

void mk_SlotX_body()
{
	mk_template_kl_classT_classp1_classp2_classp3_gr();
	O->ps("Slot");mk_nr();O->ps("<T");
		if (anz) O->ps(", ");
		mk_p1_p2_p3();O->ps(">::Slot");mk_nr();O->ps(" (T *funcclass_,\n");
	O->ps("  void (T::*func_)(");mk_constp1ref_constp2ref_constp3ref();
		O->ps("))\n");
	O->ps("  : funcclass(funcclass_), func(func_)\n");
	O->ps("{\n");
//	O->ps("  printf(\"Slot");mk_nr();O->ps(" constructed\\n\");\n");
	O->ps("}\n");
	O->pc('\n');

	mk_template_kl_classT_classp1_classp2_classp3_gr();
	O->ps("Slot");mk_nr();O->ps("<T");
		if (anz) O->ps(", ");
		mk_p1_p2_p3();O->ps(">::~Slot");mk_nr();O->ps(" ()\n");
	O->ps("{\n");
//	O->ps("  printf(\"Slot");mk_nr();O->ps(" destructed\\n\");\n");
	O->ps("  if (mysig) {\n");
//	O->ps("    printf(\"~Slot");mk_nr();O->ps(": I am connected to a signal. disconnecting...\\n\");\n");
	O->ps("    mysig->myslot=0;\n");
	O->ps("  }else{\n");
//	O->ps("    printf(\"~Slot");mk_nr();O->ps(": I ain't connected.\\n\");\n");
	O->ps("  };\n");
	O->ps("  while (first) {\n");
//	O->ps("    printf(\"Pending event found. deleting\\n\");\n");
	O->ps("\n");
	O->ps("    if (first->prevmainqueue) {\n");
	O->ps("      first->prevmainqueue->nextmainqueue=first->nextmainqueue;\n");
	O->ps("      if (first->nextmainqueue)\n");
	O->ps("        first->nextmainqueue->prevmainqueue=first->prevmainqueue;\n");
	O->ps("    }else{\n");
	O->ps("      mainQueue::first=first->nextmainqueue;\n");
	O->ps("      if (mainQueue::first) mainQueue::first->prevmainqueue=0;\n");
	O->ps("    };\n");
	O->ps("    if (mainQueue::last==first) mainQueue::last=first->prevmainqueue;\n");
	O->ps("\n");
	O->ps("    CommonEvent *old=first;\n");
	O->ps("    first=first->nextslotevent;\n");
	O->ps("    delete old;\n");
	O->ps("    if (first) first->prevslotevent=0; else last=0;\n");
	O->ps("  };\n");
	O->ps("};\n");
	O->pc('\n');

	mk_template_kl_classT_classp1_classp2_classp3_gr();
	O->ps("void Slot");mk_nr();O->ps("<T");
		if (anz) O->ps(", ");
		mk_p1_p2_p3();O->ps(">::operator ()(");
		mk_constp1refa1_constp2refa2_constp3refa3();O->ps(")\n");
	O->ps("{\n");
//	O->ps("	printf(\"Slot");mk_nr();O->ps(" received data.\\n\");\n");
	O->ps("	(funcclass->*func)(");mk_a1_a2_a3();O->ps(");\n");
	O->ps("};\n");
  O->pc('\n');
};

int main()
{
  O = new out ("sigslot.hpp");
  O->psl(header);
  int anzahl=4;
  for (anz=0;anz<anzahl;anz++) {
    O->ps("// *********************************************************\n");
    O->ps("// *********************************************************\n");
    O->ps("//  -- ");mk_nr();O->ps(" --   parameters\n");O->pc('\n');
    O->ps("// *********************************************************\n");
    O->ps("// *********************************************************\n");
    mk_CommonSlotX_header();
    if (anz) mk_CommonSlotX_body();
    mk_EventX_header();
    if (anz) mk_EventX_body();
    mk_SignalX_header();
    if (anz) mk_SignalX_body();
    mk_SlotX_header();
    mk_SlotX_body();
    mk_Connect_function();
  };
  O->pc('\n');
  O->ps("#endif\n");
  delete O;
  
  O = new out ("sigslot.cpp");
  O->psl(cppfile);
  if (anzahl>=0) {
    anz=0;
    O->ps("// *********************************************************\n");
    O->ps("// *********************************************************\n");
    O->ps("//  -- ");mk_nr();O->ps(" --   parameters\n");O->pc('\n');
    O->ps("// *********************************************************\n");
    O->ps("// *********************************************************\n");
    mk_CommonSlotX_body();
    mk_EventX_body();
    mk_SignalX_body();
  };
  delete O;
  
  return 0;
};
